/*
 * Copyright 2009-2009 the Fess Project and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package jp.sf.fess.db.bsentity;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import jp.sf.fess.db.allcommon.DBMetaInstanceHandler;
import jp.sf.fess.db.exentity.RequestHeader;
import jp.sf.fess.db.exentity.WebAuthentication;
import jp.sf.fess.db.exentity.WebConfigToBrowserTypeMapping;
import jp.sf.fess.db.exentity.WebConfigToLabelTypeMapping;
import jp.sf.fess.db.exentity.WebConfigToRoleTypeMapping;

import org.seasar.dbflute.Entity;
import org.seasar.dbflute.dbmeta.DBMeta;

/**
 * The entity of WEB_CRAWLING_CONFIG that the type is TABLE. <br />
 * <pre>
 * [primary-key]
 *     ID
 * 
 * [column]
 *     ID, NAME, URLS, INCLUDED_URLS, EXCLUDED_URLS, DEPTH, MAX_ACCESS_COUNT, USER_AGENT, NUM_OF_THREAD, INTERVAL_TIME, AVAILABLE, SORT_ORDER, CREATED_BY, CREATED_TIME, UPDATED_BY, UPDATED_TIME, DELETED_BY, DELETED_TIME, VERSION_NO
 * 
 * [sequence]
 *     
 * 
 * [identity]
 *     ID
 * 
 * [version-no]
 *     VERSION_NO
 * 
 * [foreign-table]
 *     
 * 
 * [referrer-table]
 *     REQUEST_HEADER, WEB_AUTHENTICATION, WEB_CONFIG_TO_BROWSER_TYPE_MAPPING, WEB_CONFIG_TO_LABEL_TYPE_MAPPING, WEB_CONFIG_TO_ROLE_TYPE_MAPPING
 * 
 * [foreign-property]
 *     
 * 
 * [referrer-property]
 *     requestHeaderList, webAuthenticationList, webConfigToBrowserTypeMappingList, webConfigToLabelTypeMappingList, webConfigToRoleTypeMappingList
 * </pre>
 * @author DBFlute(AutoGenerator)
 */
public abstract class BsWebCrawlingConfig implements Entity, Serializable {

    // ===================================================================================
    //                                                                          Definition
    //                                                                          ==========
    /** Serial version UID. (Default) */
    private static final long serialVersionUID = 1L;

    // ===================================================================================
    //                                                                           Attribute
    //                                                                           =========
    // -----------------------------------------------------
    //                                                Column
    //                                                ------
    /** ID: {PK : ID : NotNull : BIGINT} */
    protected Long _id;

    /** NAME: {NotNull : VARCHAR(200)} */
    protected String _name;

    /** URLS: {NotNull : VARCHAR(4000)} */
    protected String _urls;

    /** INCLUDED_URLS: {VARCHAR(4000)} */
    protected String _includedUrls;

    /** EXCLUDED_URLS: {VARCHAR(4000)} */
    protected String _excludedUrls;

    /** DEPTH: {INTEGER} */
    protected Integer _depth;

    /** MAX_ACCESS_COUNT: {BIGINT} */
    protected Long _maxAccessCount;

    /** USER_AGENT: {NotNull : VARCHAR(200)} */
    protected String _userAgent;

    /** NUM_OF_THREAD: {NotNull : INTEGER} */
    protected Integer _numOfThread;

    /** INTERVAL_TIME: {NotNull : INTEGER} */
    protected Integer _intervalTime;

    /** AVAILABLE: {NotNull : VARCHAR(1)} */
    protected String _available;

    /** SORT_ORDER: {NotNull : INTEGER} */
    protected Integer _sortOrder;

    /** CREATED_BY: {NotNull : VARCHAR(255)} */
    protected String _createdBy;

    /** CREATED_TIME: {NotNull : TIMESTAMP} */
    protected java.sql.Timestamp _createdTime;

    /** UPDATED_BY: {VARCHAR(255)} */
    protected String _updatedBy;

    /** UPDATED_TIME: {TIMESTAMP} */
    protected java.sql.Timestamp _updatedTime;

    /** DELETED_BY: {VARCHAR(255)} */
    protected String _deletedBy;

    /** DELETED_TIME: {TIMESTAMP} */
    protected java.sql.Timestamp _deletedTime;

    /** VERSION_NO: {NotNull : INTEGER} */
    protected Integer _versionNo;

    // -----------------------------------------------------
    //                                              Internal
    //                                              --------
    /** The attribute of entity modified properties. (for S2Dao) */
    protected EntityModifiedProperties _modifiedProperties = newEntityModifiedProperties();

    // ===================================================================================
    //                                                                          Table Name
    //                                                                          ==========
    public String getTableDbName() {
        return "WEB_CRAWLING_CONFIG";
    }

    public String getTablePropertyName() { // as JavaBeansRule
        return "webCrawlingConfig";
    }

    // ===================================================================================
    //                                                                              DBMeta
    //                                                                              ======
    public DBMeta getDBMeta() {
        return DBMetaInstanceHandler.findDBMeta(getTableDbName());
    }

    // ===================================================================================
    //                                                          Classification Classifying
    //                                                          ==========================
    // ===================================================================================
    //                                                        Classification Determination
    //                                                        ============================
    // ===================================================================================
    //                                                           Classification Name/Alias
    //                                                           =========================
    // ===================================================================================
    //                                                                    Foreign Property
    //                                                                    ================
    // ===================================================================================
    //                                                                   Referrer Property
    //                                                                   =================
    /** REQUEST_HEADER as 'requestHeaderList'. */
    protected List<RequestHeader> _childrenRequestHeaderList;

    /**
     * REQUEST_HEADER as 'requestHeaderList'. {without lazy-load} <br />
     * @return The entity list of referrer property 'requestHeaderList'. (NotNull: If it's not loaded yet, initializes the list instance of referrer as empty and returns it.)
     */
    public List<RequestHeader> getRequestHeaderList() {
        if (_childrenRequestHeaderList == null) {
            _childrenRequestHeaderList = new ArrayList<RequestHeader>();
        }
        return _childrenRequestHeaderList;
    }

    /**
     * REQUEST_HEADER as 'requestHeaderList'.
     * @param requestHeaderList The entity list of referrer property 'requestHeaderList'. (Nullable)
     */
    public void setRequestHeaderList(List<RequestHeader> requestHeaderList) {
        _childrenRequestHeaderList = requestHeaderList;
    }

    /** WEB_AUTHENTICATION as 'webAuthenticationList'. */
    protected List<WebAuthentication> _childrenWebAuthenticationList;

    /**
     * WEB_AUTHENTICATION as 'webAuthenticationList'. {without lazy-load} <br />
     * @return The entity list of referrer property 'webAuthenticationList'. (NotNull: If it's not loaded yet, initializes the list instance of referrer as empty and returns it.)
     */
    public List<WebAuthentication> getWebAuthenticationList() {
        if (_childrenWebAuthenticationList == null) {
            _childrenWebAuthenticationList = new ArrayList<WebAuthentication>();
        }
        return _childrenWebAuthenticationList;
    }

    /**
     * WEB_AUTHENTICATION as 'webAuthenticationList'.
     * @param webAuthenticationList The entity list of referrer property 'webAuthenticationList'. (Nullable)
     */
    public void setWebAuthenticationList(
            List<WebAuthentication> webAuthenticationList) {
        _childrenWebAuthenticationList = webAuthenticationList;
    }

    /** WEB_CONFIG_TO_BROWSER_TYPE_MAPPING as 'webConfigToBrowserTypeMappingList'. */
    protected List<WebConfigToBrowserTypeMapping> _childrenWebConfigToBrowserTypeMappingList;

    /**
     * WEB_CONFIG_TO_BROWSER_TYPE_MAPPING as 'webConfigToBrowserTypeMappingList'. {without lazy-load} <br />
     * @return The entity list of referrer property 'webConfigToBrowserTypeMappingList'. (NotNull: If it's not loaded yet, initializes the list instance of referrer as empty and returns it.)
     */
    public List<WebConfigToBrowserTypeMapping> getWebConfigToBrowserTypeMappingList() {
        if (_childrenWebConfigToBrowserTypeMappingList == null) {
            _childrenWebConfigToBrowserTypeMappingList = new ArrayList<WebConfigToBrowserTypeMapping>();
        }
        return _childrenWebConfigToBrowserTypeMappingList;
    }

    /**
     * WEB_CONFIG_TO_BROWSER_TYPE_MAPPING as 'webConfigToBrowserTypeMappingList'.
     * @param webConfigToBrowserTypeMappingList The entity list of referrer property 'webConfigToBrowserTypeMappingList'. (Nullable)
     */
    public void setWebConfigToBrowserTypeMappingList(
            List<WebConfigToBrowserTypeMapping> webConfigToBrowserTypeMappingList) {
        _childrenWebConfigToBrowserTypeMappingList = webConfigToBrowserTypeMappingList;
    }

    /** WEB_CONFIG_TO_LABEL_TYPE_MAPPING as 'webConfigToLabelTypeMappingList'. */
    protected List<WebConfigToLabelTypeMapping> _childrenWebConfigToLabelTypeMappingList;

    /**
     * WEB_CONFIG_TO_LABEL_TYPE_MAPPING as 'webConfigToLabelTypeMappingList'. {without lazy-load} <br />
     * @return The entity list of referrer property 'webConfigToLabelTypeMappingList'. (NotNull: If it's not loaded yet, initializes the list instance of referrer as empty and returns it.)
     */
    public List<WebConfigToLabelTypeMapping> getWebConfigToLabelTypeMappingList() {
        if (_childrenWebConfigToLabelTypeMappingList == null) {
            _childrenWebConfigToLabelTypeMappingList = new ArrayList<WebConfigToLabelTypeMapping>();
        }
        return _childrenWebConfigToLabelTypeMappingList;
    }

    /**
     * WEB_CONFIG_TO_LABEL_TYPE_MAPPING as 'webConfigToLabelTypeMappingList'.
     * @param webConfigToLabelTypeMappingList The entity list of referrer property 'webConfigToLabelTypeMappingList'. (Nullable)
     */
    public void setWebConfigToLabelTypeMappingList(
            List<WebConfigToLabelTypeMapping> webConfigToLabelTypeMappingList) {
        _childrenWebConfigToLabelTypeMappingList = webConfigToLabelTypeMappingList;
    }

    /** WEB_CONFIG_TO_ROLE_TYPE_MAPPING as 'webConfigToRoleTypeMappingList'. */
    protected List<WebConfigToRoleTypeMapping> _childrenWebConfigToRoleTypeMappingList;

    /**
     * WEB_CONFIG_TO_ROLE_TYPE_MAPPING as 'webConfigToRoleTypeMappingList'. {without lazy-load} <br />
     * @return The entity list of referrer property 'webConfigToRoleTypeMappingList'. (NotNull: If it's not loaded yet, initializes the list instance of referrer as empty and returns it.)
     */
    public List<WebConfigToRoleTypeMapping> getWebConfigToRoleTypeMappingList() {
        if (_childrenWebConfigToRoleTypeMappingList == null) {
            _childrenWebConfigToRoleTypeMappingList = new ArrayList<WebConfigToRoleTypeMapping>();
        }
        return _childrenWebConfigToRoleTypeMappingList;
    }

    /**
     * WEB_CONFIG_TO_ROLE_TYPE_MAPPING as 'webConfigToRoleTypeMappingList'.
     * @param webConfigToRoleTypeMappingList The entity list of referrer property 'webConfigToRoleTypeMappingList'. (Nullable)
     */
    public void setWebConfigToRoleTypeMappingList(
            List<WebConfigToRoleTypeMapping> webConfigToRoleTypeMappingList) {
        _childrenWebConfigToRoleTypeMappingList = webConfigToRoleTypeMappingList;
    }

    // ===================================================================================
    //                                                                       Determination
    //                                                                       =============
    public boolean hasPrimaryKeyValue() {
        if (_id == null) {
            return false;
        }
        return true;
    }

    // ===================================================================================
    //                                                                 Modified Properties
    //                                                                 ===================
    public Set<String> getModifiedPropertyNames() {
        return _modifiedProperties.getPropertyNames();
    }

    protected EntityModifiedProperties newEntityModifiedProperties() {
        return new EntityModifiedProperties();
    }

    public void clearModifiedPropertyNames() {
        _modifiedProperties.clear();
    }

    public boolean hasModification() {
        return !_modifiedProperties.isEmpty();
    }

    // ===================================================================================
    //                                                                      Basic Override
    //                                                                      ==============
    /**
     * If the primary-key of the other is same as this one, returns true.
     * @param other Other entity.
     * @return Comparing result.
     */
    public boolean equals(Object other) {
        if (other == null || !(other instanceof BsWebCrawlingConfig)) {
            return false;
        }
        BsWebCrawlingConfig otherEntity = (BsWebCrawlingConfig) other;
        if (!helpComparingValue(getId(), otherEntity.getId())) {
            return false;
        }
        return true;
    }

    protected boolean helpComparingValue(Object value1, Object value2) {
        if (value1 == null && value2 == null) {
            return true;
        }
        return value1 != null && value2 != null && value1.equals(value2);
    }

    /**
     * Calculates hash-code from primary-key.
     * @return Hash-code from primary-key.
     */
    public int hashCode() {
        int result = 17;
        if (getId() != null) {
            result = (31 * result) + getId().hashCode();
        }
        return result;
    }

    /**
     * @return The view string of all columns. (NotNull)
     */
    public String toString() {
        String delimiter = ",";
        StringBuilder sb = new StringBuilder();
        sb.append(delimiter).append(getId());
        sb.append(delimiter).append(getName());
        sb.append(delimiter).append(getUrls());
        sb.append(delimiter).append(getIncludedUrls());
        sb.append(delimiter).append(getExcludedUrls());
        sb.append(delimiter).append(getDepth());
        sb.append(delimiter).append(getMaxAccessCount());
        sb.append(delimiter).append(getUserAgent());
        sb.append(delimiter).append(getNumOfThread());
        sb.append(delimiter).append(getIntervalTime());
        sb.append(delimiter).append(getAvailable());
        sb.append(delimiter).append(getSortOrder());
        sb.append(delimiter).append(getCreatedBy());
        sb.append(delimiter).append(getCreatedTime());
        sb.append(delimiter).append(getUpdatedBy());
        sb.append(delimiter).append(getUpdatedTime());
        sb.append(delimiter).append(getDeletedBy());
        sb.append(delimiter).append(getDeletedTime());
        sb.append(delimiter).append(getVersionNo());
        if (sb.length() > 0) {
            sb.delete(0, delimiter.length());
        }
        sb.insert(0, "{").append("}");
        return sb.toString();
    }

    // ===================================================================================
    //                                                                            Accessor
    //                                                                            ========
    /**
     * ID: {PK : ID : NotNull : BIGINT} <br />
     * @return The value of the column 'ID'. (Nullable)
     */
    public Long getId() {
        return _id;
    }

    /**
     * ID: {PK : ID : NotNull : BIGINT} <br />
     * @param id The value of the column 'ID'. (Nullable)
     */
    public void setId(Long id) {
        _modifiedProperties.addPropertyName("id");
        this._id = id;
    }

    /**
     * NAME: {NotNull : VARCHAR(200)} <br />
     * @return The value of the column 'NAME'. (Nullable)
     */
    public String getName() {
        return _name;
    }

    /**
     * NAME: {NotNull : VARCHAR(200)} <br />
     * @param name The value of the column 'NAME'. (Nullable)
     */
    public void setName(String name) {
        _modifiedProperties.addPropertyName("name");
        this._name = name;
    }

    /**
     * URLS: {NotNull : VARCHAR(4000)} <br />
     * @return The value of the column 'URLS'. (Nullable)
     */
    public String getUrls() {
        return _urls;
    }

    /**
     * URLS: {NotNull : VARCHAR(4000)} <br />
     * @param urls The value of the column 'URLS'. (Nullable)
     */
    public void setUrls(String urls) {
        _modifiedProperties.addPropertyName("urls");
        this._urls = urls;
    }

    /**
     * INCLUDED_URLS: {VARCHAR(4000)} <br />
     * @return The value of the column 'INCLUDED_URLS'. (Nullable)
     */
    public String getIncludedUrls() {
        return _includedUrls;
    }

    /**
     * INCLUDED_URLS: {VARCHAR(4000)} <br />
     * @param includedUrls The value of the column 'INCLUDED_URLS'. (Nullable)
     */
    public void setIncludedUrls(String includedUrls) {
        _modifiedProperties.addPropertyName("includedUrls");
        this._includedUrls = includedUrls;
    }

    /**
     * EXCLUDED_URLS: {VARCHAR(4000)} <br />
     * @return The value of the column 'EXCLUDED_URLS'. (Nullable)
     */
    public String getExcludedUrls() {
        return _excludedUrls;
    }

    /**
     * EXCLUDED_URLS: {VARCHAR(4000)} <br />
     * @param excludedUrls The value of the column 'EXCLUDED_URLS'. (Nullable)
     */
    public void setExcludedUrls(String excludedUrls) {
        _modifiedProperties.addPropertyName("excludedUrls");
        this._excludedUrls = excludedUrls;
    }

    /**
     * DEPTH: {INTEGER} <br />
     * @return The value of the column 'DEPTH'. (Nullable)
     */
    public Integer getDepth() {
        return _depth;
    }

    /**
     * DEPTH: {INTEGER} <br />
     * @param depth The value of the column 'DEPTH'. (Nullable)
     */
    public void setDepth(Integer depth) {
        _modifiedProperties.addPropertyName("depth");
        this._depth = depth;
    }

    /**
     * MAX_ACCESS_COUNT: {BIGINT} <br />
     * @return The value of the column 'MAX_ACCESS_COUNT'. (Nullable)
     */
    public Long getMaxAccessCount() {
        return _maxAccessCount;
    }

    /**
     * MAX_ACCESS_COUNT: {BIGINT} <br />
     * @param maxAccessCount The value of the column 'MAX_ACCESS_COUNT'. (Nullable)
     */
    public void setMaxAccessCount(Long maxAccessCount) {
        _modifiedProperties.addPropertyName("maxAccessCount");
        this._maxAccessCount = maxAccessCount;
    }

    /**
     * USER_AGENT: {NotNull : VARCHAR(200)} <br />
     * @return The value of the column 'USER_AGENT'. (Nullable)
     */
    public String getUserAgent() {
        return _userAgent;
    }

    /**
     * USER_AGENT: {NotNull : VARCHAR(200)} <br />
     * @param userAgent The value of the column 'USER_AGENT'. (Nullable)
     */
    public void setUserAgent(String userAgent) {
        _modifiedProperties.addPropertyName("userAgent");
        this._userAgent = userAgent;
    }

    /**
     * NUM_OF_THREAD: {NotNull : INTEGER} <br />
     * @return The value of the column 'NUM_OF_THREAD'. (Nullable)
     */
    public Integer getNumOfThread() {
        return _numOfThread;
    }

    /**
     * NUM_OF_THREAD: {NotNull : INTEGER} <br />
     * @param numOfThread The value of the column 'NUM_OF_THREAD'. (Nullable)
     */
    public void setNumOfThread(Integer numOfThread) {
        _modifiedProperties.addPropertyName("numOfThread");
        this._numOfThread = numOfThread;
    }

    /**
     * INTERVAL_TIME: {NotNull : INTEGER} <br />
     * @return The value of the column 'INTERVAL_TIME'. (Nullable)
     */
    public Integer getIntervalTime() {
        return _intervalTime;
    }

    /**
     * INTERVAL_TIME: {NotNull : INTEGER} <br />
     * @param intervalTime The value of the column 'INTERVAL_TIME'. (Nullable)
     */
    public void setIntervalTime(Integer intervalTime) {
        _modifiedProperties.addPropertyName("intervalTime");
        this._intervalTime = intervalTime;
    }

    /**
     * AVAILABLE: {NotNull : VARCHAR(1)} <br />
     * @return The value of the column 'AVAILABLE'. (Nullable)
     */
    public String getAvailable() {
        return _available;
    }

    /**
     * AVAILABLE: {NotNull : VARCHAR(1)} <br />
     * @param available The value of the column 'AVAILABLE'. (Nullable)
     */
    public void setAvailable(String available) {
        _modifiedProperties.addPropertyName("available");
        this._available = available;
    }

    /**
     * SORT_ORDER: {NotNull : INTEGER} <br />
     * @return The value of the column 'SORT_ORDER'. (Nullable)
     */
    public Integer getSortOrder() {
        return _sortOrder;
    }

    /**
     * SORT_ORDER: {NotNull : INTEGER} <br />
     * @param sortOrder The value of the column 'SORT_ORDER'. (Nullable)
     */
    public void setSortOrder(Integer sortOrder) {
        _modifiedProperties.addPropertyName("sortOrder");
        this._sortOrder = sortOrder;
    }

    /**
     * CREATED_BY: {NotNull : VARCHAR(255)} <br />
     * @return The value of the column 'CREATED_BY'. (Nullable)
     */
    public String getCreatedBy() {
        return _createdBy;
    }

    /**
     * CREATED_BY: {NotNull : VARCHAR(255)} <br />
     * @param createdBy The value of the column 'CREATED_BY'. (Nullable)
     */
    public void setCreatedBy(String createdBy) {
        _modifiedProperties.addPropertyName("createdBy");
        this._createdBy = createdBy;
    }

    /**
     * CREATED_TIME: {NotNull : TIMESTAMP} <br />
     * @return The value of the column 'CREATED_TIME'. (Nullable)
     */
    public java.sql.Timestamp getCreatedTime() {
        return _createdTime;
    }

    /**
     * CREATED_TIME: {NotNull : TIMESTAMP} <br />
     * @param createdTime The value of the column 'CREATED_TIME'. (Nullable)
     */
    public void setCreatedTime(java.sql.Timestamp createdTime) {
        _modifiedProperties.addPropertyName("createdTime");
        this._createdTime = createdTime;
    }

    /**
     * UPDATED_BY: {VARCHAR(255)} <br />
     * @return The value of the column 'UPDATED_BY'. (Nullable)
     */
    public String getUpdatedBy() {
        return _updatedBy;
    }

    /**
     * UPDATED_BY: {VARCHAR(255)} <br />
     * @param updatedBy The value of the column 'UPDATED_BY'. (Nullable)
     */
    public void setUpdatedBy(String updatedBy) {
        _modifiedProperties.addPropertyName("updatedBy");
        this._updatedBy = updatedBy;
    }

    /**
     * UPDATED_TIME: {TIMESTAMP} <br />
     * @return The value of the column 'UPDATED_TIME'. (Nullable)
     */
    public java.sql.Timestamp getUpdatedTime() {
        return _updatedTime;
    }

    /**
     * UPDATED_TIME: {TIMESTAMP} <br />
     * @param updatedTime The value of the column 'UPDATED_TIME'. (Nullable)
     */
    public void setUpdatedTime(java.sql.Timestamp updatedTime) {
        _modifiedProperties.addPropertyName("updatedTime");
        this._updatedTime = updatedTime;
    }

    /**
     * DELETED_BY: {VARCHAR(255)} <br />
     * @return The value of the column 'DELETED_BY'. (Nullable)
     */
    public String getDeletedBy() {
        return _deletedBy;
    }

    /**
     * DELETED_BY: {VARCHAR(255)} <br />
     * @param deletedBy The value of the column 'DELETED_BY'. (Nullable)
     */
    public void setDeletedBy(String deletedBy) {
        _modifiedProperties.addPropertyName("deletedBy");
        this._deletedBy = deletedBy;
    }

    /**
     * DELETED_TIME: {TIMESTAMP} <br />
     * @return The value of the column 'DELETED_TIME'. (Nullable)
     */
    public java.sql.Timestamp getDeletedTime() {
        return _deletedTime;
    }

    /**
     * DELETED_TIME: {TIMESTAMP} <br />
     * @param deletedTime The value of the column 'DELETED_TIME'. (Nullable)
     */
    public void setDeletedTime(java.sql.Timestamp deletedTime) {
        _modifiedProperties.addPropertyName("deletedTime");
        this._deletedTime = deletedTime;
    }

    /**
     * VERSION_NO: {NotNull : INTEGER} <br />
     * @return The value of the column 'VERSION_NO'. (Nullable)
     */
    public Integer getVersionNo() {
        return _versionNo;
    }

    /**
     * VERSION_NO: {NotNull : INTEGER} <br />
     * @param versionNo The value of the column 'VERSION_NO'. (Nullable)
     */
    public void setVersionNo(Integer versionNo) {
        _modifiedProperties.addPropertyName("versionNo");
        this._versionNo = versionNo;
    }
}
