/*
 * Copyright 2009-2009 the Fess Project and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package jp.sf.fess.db.bsentity.dbmeta;

import java.util.List;
import java.util.Map;

import jp.sf.fess.db.exentity.FileCrawlingConfig;

import org.seasar.dbflute.Entity;
import org.seasar.dbflute.dbmeta.AbstractDBMeta;
import org.seasar.dbflute.dbmeta.info.ColumnInfo;
import org.seasar.dbflute.dbmeta.info.ReferrerInfo;
import org.seasar.dbflute.dbmeta.info.UniqueInfo;
import org.seasar.dbflute.helper.StringKeyMap;

/**
 * The DB meta of FILE_CRAWLING_CONFIG. (Singleton)
 * @author DBFlute(AutoGenerator)
 */
public class FileCrawlingConfigDbm extends AbstractDBMeta {

    // ===================================================================================
    //                                                                           Singleton
    //                                                                           =========
    private static final FileCrawlingConfigDbm _instance = new FileCrawlingConfigDbm();

    private FileCrawlingConfigDbm() {
    }

    public static FileCrawlingConfigDbm getInstance() {
        return _instance;
    }

    // ===================================================================================
    //                                                                          Table Info
    //                                                                          ==========
    public String getTableDbName() {
        return "FILE_CRAWLING_CONFIG";
    }

    public String getTablePropertyName() {
        return "fileCrawlingConfig";
    }

    public String getTableSqlName() {
        return "FILE_CRAWLING_CONFIG";
    }

    // ===================================================================================
    //                                                                         Column Info
    //                                                                         ===========
    protected ColumnInfo _columnId = cci("ID", null, "id", Long.class, true,
            true, null, null);

    protected ColumnInfo _columnName = cci("NAME", null, "name", String.class,
            false, false, 200, 0);

    protected ColumnInfo _columnPaths = cci("PATHS", null, "paths",
            String.class, false, false, 4000, 0);

    protected ColumnInfo _columnIncludedPaths = cci("INCLUDED_PATHS", null,
            "includedPaths", String.class, false, false, 4000, 0);

    protected ColumnInfo _columnExcludedPaths = cci("EXCLUDED_PATHS", null,
            "excludedPaths", String.class, false, false, 4000, 0);

    protected ColumnInfo _columnDepth = cci("DEPTH", null, "depth",
            Integer.class, false, false, null, null);

    protected ColumnInfo _columnMaxAccessCount = cci("MAX_ACCESS_COUNT", null,
            "maxAccessCount", Long.class, false, false, null, null);

    protected ColumnInfo _columnNumOfThread = cci("NUM_OF_THREAD", null,
            "numOfThread", Integer.class, false, false, null, null);

    protected ColumnInfo _columnIntervalTime = cci("INTERVAL_TIME", null,
            "intervalTime", Integer.class, false, false, null, null);

    protected ColumnInfo _columnAvailable = cci("AVAILABLE", null, "available",
            String.class, false, false, 1, 0);

    protected ColumnInfo _columnSortOrder = cci("SORT_ORDER", null,
            "sortOrder", Integer.class, false, false, null, null);

    protected ColumnInfo _columnCreatedBy = cci("CREATED_BY", null,
            "createdBy", String.class, false, false, 255, 0);

    protected ColumnInfo _columnCreatedTime = cci("CREATED_TIME", null,
            "createdTime", java.sql.Timestamp.class, false, false, null, null);

    protected ColumnInfo _columnUpdatedBy = cci("UPDATED_BY", null,
            "updatedBy", String.class, false, false, 255, 0);

    protected ColumnInfo _columnUpdatedTime = cci("UPDATED_TIME", null,
            "updatedTime", java.sql.Timestamp.class, false, false, null, null);

    protected ColumnInfo _columnDeletedBy = cci("DELETED_BY", null,
            "deletedBy", String.class, false, false, 255, 0);

    protected ColumnInfo _columnDeletedTime = cci("DELETED_TIME", null,
            "deletedTime", java.sql.Timestamp.class, false, false, null, null);

    protected ColumnInfo _columnVersionNo = cci("VERSION_NO", null,
            "versionNo", Integer.class, false, false, null, null,
            OptimisticLockType.VERSION_NO);

    public ColumnInfo columnId() {
        return _columnId;
    }

    public ColumnInfo columnName() {
        return _columnName;
    }

    public ColumnInfo columnPaths() {
        return _columnPaths;
    }

    public ColumnInfo columnIncludedPaths() {
        return _columnIncludedPaths;
    }

    public ColumnInfo columnExcludedPaths() {
        return _columnExcludedPaths;
    }

    public ColumnInfo columnDepth() {
        return _columnDepth;
    }

    public ColumnInfo columnMaxAccessCount() {
        return _columnMaxAccessCount;
    }

    public ColumnInfo columnNumOfThread() {
        return _columnNumOfThread;
    }

    public ColumnInfo columnIntervalTime() {
        return _columnIntervalTime;
    }

    public ColumnInfo columnAvailable() {
        return _columnAvailable;
    }

    public ColumnInfo columnSortOrder() {
        return _columnSortOrder;
    }

    public ColumnInfo columnCreatedBy() {
        return _columnCreatedBy;
    }

    public ColumnInfo columnCreatedTime() {
        return _columnCreatedTime;
    }

    public ColumnInfo columnUpdatedBy() {
        return _columnUpdatedBy;
    }

    public ColumnInfo columnUpdatedTime() {
        return _columnUpdatedTime;
    }

    public ColumnInfo columnDeletedBy() {
        return _columnDeletedBy;
    }

    public ColumnInfo columnDeletedTime() {
        return _columnDeletedTime;
    }

    public ColumnInfo columnVersionNo() {
        return _columnVersionNo;
    }

    {
        initializeInformationResource();
    }

    // ===================================================================================
    //                                                                         Unique Info
    //                                                                         ===========
    // -----------------------------------------------------
    //                                       Primary Element
    //                                       ---------------
    public UniqueInfo getPrimaryUniqueInfo() {
        return cpui(columnId());
    }

    public boolean hasPrimaryKey() {
        return true;
    }

    public boolean hasTwoOrMorePrimaryKeys() {
        return false;
    }

    // ===================================================================================
    //                                                                       Relation Info
    //                                                                       =============
    // -----------------------------------------------------
    //                                      Foreign Property
    //                                      ----------------

    // -----------------------------------------------------
    //                                     Referrer Property
    //                                     -----------------
    public ReferrerInfo referrerFileConfigToBrowserTypeMappingList() {
        Map<ColumnInfo, ColumnInfo> map = newLinkedHashMap(columnId(),
                FileConfigToBrowserTypeMappingDbm.getInstance()
                        .columnFileConfigId());
        return cri("fileConfigToBrowserTypeMappingList", this,
                FileConfigToBrowserTypeMappingDbm.getInstance(), map, false);
    }

    public ReferrerInfo referrerFileConfigToLabelTypeMappingList() {
        Map<ColumnInfo, ColumnInfo> map = newLinkedHashMap(columnId(),
                FileConfigToLabelTypeMappingDbm.getInstance()
                        .columnFileConfigId());
        return cri("fileConfigToLabelTypeMappingList", this,
                FileConfigToLabelTypeMappingDbm.getInstance(), map, false);
    }

    public ReferrerInfo referrerFileConfigToRoleTypeMappingList() {
        Map<ColumnInfo, ColumnInfo> map = newLinkedHashMap(columnId(),
                FileConfigToRoleTypeMappingDbm.getInstance()
                        .columnFileConfigId());
        return cri("fileConfigToRoleTypeMappingList", this,
                FileConfigToRoleTypeMappingDbm.getInstance(), map, false);
    }

    // ===================================================================================
    //                                                                        Various Info
    //                                                                        ============
    public boolean hasIdentity() {
        return true;
    }

    public boolean hasVersionNo() {
        return true;
    }

    public ColumnInfo getVersionNoColumnInfo() {
        return _columnVersionNo;
    }

    // ===================================================================================
    //                                                                           Type Name
    //                                                                           =========
    public String getEntityTypeName() {
        return "jp.sf.fess.db.exentity.FileCrawlingConfig";
    }

    public String getConditionBeanTypeName() {
        return "jp.sf.fess.db.cbean.bs.FileCrawlingConfigCB";
    }

    public String getDaoTypeName() {
        return "jp.sf.fess.db.exdao.FileCrawlingConfigDao";
    }

    public String getBehaviorTypeName() {
        return "jp.sf.fess.db.exbhv.FileCrawlingConfigBhv";
    }

    // ===================================================================================
    //                                                                         Object Type
    //                                                                         ===========
    public Class<FileCrawlingConfig> getEntityType() {
        return FileCrawlingConfig.class;
    }

    // ===================================================================================
    //                                                                     Object Instance
    //                                                                     ===============
    public Entity newEntity() {
        return newMyEntity();
    }

    public FileCrawlingConfig newMyEntity() {
        return new FileCrawlingConfig();
    }

    // ===================================================================================
    //                                                                     Entity Handling
    //                                                                     ===============  
    // -----------------------------------------------------
    //                                                Accept
    //                                                ------
    public void acceptPrimaryKeyMap(Entity entity,
            Map<String, ? extends Object> primaryKeyMap) {
        doAcceptPrimaryKeyMap((FileCrawlingConfig) entity, primaryKeyMap,
                _epsMap);
    }

    public void acceptPrimaryKeyMapString(Entity entity,
            String primaryKeyMapString) {
        MapStringUtil.acceptPrimaryKeyMapString(primaryKeyMapString, entity);
    }

    public void acceptColumnValueMap(Entity entity,
            Map<String, ? extends Object> columnValueMap) {
        doAcceptColumnValueMap((FileCrawlingConfig) entity, columnValueMap,
                _epsMap);
    }

    public void acceptColumnValueMapString(Entity entity,
            String columnValueMapString) {
        MapStringUtil.acceptColumnValueMapString(columnValueMapString, entity);
    }

    // -----------------------------------------------------
    //                                               Extract
    //                                               -------
    public String extractPrimaryKeyMapString(Entity entity) {
        return MapStringUtil.extractPrimaryKeyMapString(entity);
    }

    public String extractPrimaryKeyMapString(Entity entity, String startBrace,
            String endBrace, String delimiter, String equal) {
        return doExtractPrimaryKeyMapString(entity, startBrace, endBrace,
                delimiter, equal);
    }

    public String extractColumnValueMapString(Entity entity) {
        return MapStringUtil.extractColumnValueMapString(entity);
    }

    public String extractColumnValueMapString(Entity entity, String startBrace,
            String endBrace, String delimiter, String equal) {
        return doExtractColumnValueMapString(entity, startBrace, endBrace,
                delimiter, equal);
    }

    // -----------------------------------------------------
    //                                               Convert
    //                                               -------
    public List<Object> convertToColumnValueList(Entity entity) {
        return newArrayList(convertToColumnValueMap(entity).values());
    }

    public Map<String, Object> convertToColumnValueMap(Entity entity) {
        return doConvertToColumnValueMap(entity);
    }

    public List<String> convertToColumnStringValueList(Entity entity) {
        return newArrayList(convertToColumnStringValueMap(entity).values());
    }

    public Map<String, String> convertToColumnStringValueMap(Entity entity) {
        return doConvertToColumnStringValueMap(entity);
    }

    // ===================================================================================
    //                                                               Entity Property Setup
    //                                                               =====================
    // It's very INTERNAL!
    protected final Map<String, Eps<FileCrawlingConfig>> _epsMap = StringKeyMap
            .createAsFlexibleConcurrent();
    {
        setupEps(_epsMap, new EpsId(), columnId());
        setupEps(_epsMap, new EpsName(), columnName());
        setupEps(_epsMap, new EpsPaths(), columnPaths());
        setupEps(_epsMap, new EpsIncludedPaths(), columnIncludedPaths());
        setupEps(_epsMap, new EpsExcludedPaths(), columnExcludedPaths());
        setupEps(_epsMap, new EpsDepth(), columnDepth());
        setupEps(_epsMap, new EpsMaxAccessCount(), columnMaxAccessCount());
        setupEps(_epsMap, new EpsNumOfThread(), columnNumOfThread());
        setupEps(_epsMap, new EpsIntervalTime(), columnIntervalTime());
        setupEps(_epsMap, new EpsAvailable(), columnAvailable());
        setupEps(_epsMap, new EpsSortOrder(), columnSortOrder());
        setupEps(_epsMap, new EpsCreatedBy(), columnCreatedBy());
        setupEps(_epsMap, new EpsCreatedTime(), columnCreatedTime());
        setupEps(_epsMap, new EpsUpdatedBy(), columnUpdatedBy());
        setupEps(_epsMap, new EpsUpdatedTime(), columnUpdatedTime());
        setupEps(_epsMap, new EpsDeletedBy(), columnDeletedBy());
        setupEps(_epsMap, new EpsDeletedTime(), columnDeletedTime());
        setupEps(_epsMap, new EpsVersionNo(), columnVersionNo());
    }

    public boolean hasEntityPropertySetupper(String propertyName) {
        return _epsMap.containsKey(propertyName);
    }

    public void setupEntityProperty(String propertyName, Object entity,
            Object value) {
        findEps(_epsMap, propertyName)
                .setup((FileCrawlingConfig) entity, value);
    }

    public static class EpsId implements Eps<FileCrawlingConfig> {
        public void setup(FileCrawlingConfig e, Object v) {
            e.setId((Long) v);
        }
    }

    public static class EpsName implements Eps<FileCrawlingConfig> {
        public void setup(FileCrawlingConfig e, Object v) {
            e.setName((String) v);
        }
    }

    public static class EpsPaths implements Eps<FileCrawlingConfig> {
        public void setup(FileCrawlingConfig e, Object v) {
            e.setPaths((String) v);
        }
    }

    public static class EpsIncludedPaths implements Eps<FileCrawlingConfig> {
        public void setup(FileCrawlingConfig e, Object v) {
            e.setIncludedPaths((String) v);
        }
    }

    public static class EpsExcludedPaths implements Eps<FileCrawlingConfig> {
        public void setup(FileCrawlingConfig e, Object v) {
            e.setExcludedPaths((String) v);
        }
    }

    public static class EpsDepth implements Eps<FileCrawlingConfig> {
        public void setup(FileCrawlingConfig e, Object v) {
            e.setDepth((Integer) v);
        }
    }

    public static class EpsMaxAccessCount implements Eps<FileCrawlingConfig> {
        public void setup(FileCrawlingConfig e, Object v) {
            e.setMaxAccessCount((Long) v);
        }
    }

    public static class EpsNumOfThread implements Eps<FileCrawlingConfig> {
        public void setup(FileCrawlingConfig e, Object v) {
            e.setNumOfThread((Integer) v);
        }
    }

    public static class EpsIntervalTime implements Eps<FileCrawlingConfig> {
        public void setup(FileCrawlingConfig e, Object v) {
            e.setIntervalTime((Integer) v);
        }
    }

    public static class EpsAvailable implements Eps<FileCrawlingConfig> {
        public void setup(FileCrawlingConfig e, Object v) {
            e.setAvailable((String) v);
        }
    }

    public static class EpsSortOrder implements Eps<FileCrawlingConfig> {
        public void setup(FileCrawlingConfig e, Object v) {
            e.setSortOrder((Integer) v);
        }
    }

    public static class EpsCreatedBy implements Eps<FileCrawlingConfig> {
        public void setup(FileCrawlingConfig e, Object v) {
            e.setCreatedBy((String) v);
        }
    }

    public static class EpsCreatedTime implements Eps<FileCrawlingConfig> {
        public void setup(FileCrawlingConfig e, Object v) {
            e.setCreatedTime((java.sql.Timestamp) v);
        }
    }

    public static class EpsUpdatedBy implements Eps<FileCrawlingConfig> {
        public void setup(FileCrawlingConfig e, Object v) {
            e.setUpdatedBy((String) v);
        }
    }

    public static class EpsUpdatedTime implements Eps<FileCrawlingConfig> {
        public void setup(FileCrawlingConfig e, Object v) {
            e.setUpdatedTime((java.sql.Timestamp) v);
        }
    }

    public static class EpsDeletedBy implements Eps<FileCrawlingConfig> {
        public void setup(FileCrawlingConfig e, Object v) {
            e.setDeletedBy((String) v);
        }
    }

    public static class EpsDeletedTime implements Eps<FileCrawlingConfig> {
        public void setup(FileCrawlingConfig e, Object v) {
            e.setDeletedTime((java.sql.Timestamp) v);
        }
    }

    public static class EpsVersionNo implements Eps<FileCrawlingConfig> {
        public void setup(FileCrawlingConfig e, Object v) {
            e.setVersionNo((Integer) v);
        }
    }
}
