/*
 * Copyright 2009-2009 the Fess Project and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package jp.sf.fess.db.cbean.cq.ciq;

import jp.sf.fess.db.cbean.WebCrawlingConfigCB;
import jp.sf.fess.db.cbean.cq.RequestHeaderCQ;
import jp.sf.fess.db.cbean.cq.WebAuthenticationCQ;
import jp.sf.fess.db.cbean.cq.WebConfigToBrowserTypeMappingCQ;
import jp.sf.fess.db.cbean.cq.WebConfigToLabelTypeMappingCQ;
import jp.sf.fess.db.cbean.cq.WebConfigToRoleTypeMappingCQ;
import jp.sf.fess.db.cbean.cq.WebCrawlingConfigCQ;
import jp.sf.fess.db.cbean.cq.bs.AbstractBsWebCrawlingConfigCQ;
import jp.sf.fess.db.cbean.cq.bs.BsWebCrawlingConfigCQ;

import org.seasar.dbflute.cbean.ConditionQuery;
import org.seasar.dbflute.cbean.ckey.ConditionKey;
import org.seasar.dbflute.cbean.coption.ConditionOption;
import org.seasar.dbflute.cbean.cvalue.ConditionValue;
import org.seasar.dbflute.cbean.sqlclause.SqlClause;

/**
 * The condition-inline-query of WEB_CRAWLING_CONFIG.
 * @author DBFlute(AutoGenerator)
 */
public class WebCrawlingConfigCIQ extends AbstractBsWebCrawlingConfigCQ {

    // ===================================================================================
    //                                                                           Attribute
    //                                                                           =========
    protected BsWebCrawlingConfigCQ _myCQ;

    // ===================================================================================
    //                                                                         Constructor
    //                                                                         ===========
    public WebCrawlingConfigCIQ(ConditionQuery childQuery, SqlClause sqlClause,
            String aliasName, int nestLevel, BsWebCrawlingConfigCQ myCQ) {
        super(childQuery, sqlClause, aliasName, nestLevel);
        _myCQ = myCQ;
        _foreignPropertyName = _myCQ.getForeignPropertyName();// Accept foreign property name.
        _relationPath = _myCQ.getRelationPath();// Accept relation path.
    }

    // ===================================================================================
    //                                                             Override about Register
    //                                                             =======================
    @Override
    protected void reflectRelationOnUnionQuery(ConditionQuery baseQueryAsSuper,
            ConditionQuery unionQueryAsSuper) {
        throw new UnsupportedOperationException(
                "InlineQuery must not need UNION method: " + baseQueryAsSuper
                        + " : " + unionQueryAsSuper);
    }

    @Override
    protected void setupConditionValueAndRegisterWhereClause(ConditionKey k,
            Object v, ConditionValue cv, String col) {
        regIQ(k, v, cv, col);
    }

    @Override
    protected void setupConditionValueAndRegisterWhereClause(ConditionKey k,
            Object v, ConditionValue cv, String col, ConditionOption op) {
        regIQ(k, v, cv, col, op);
    }

    @Override
    protected void registerWhereClause(String whereClause) {
        registerInlineWhereClause(whereClause);
    }

    @Override
    protected String getInScopeSubQueryRealColumnName(String columnName) {
        if (_onClauseInline) {
            throw new UnsupportedOperationException(
                    "InScopeSubQuery of on-clause is unsupported");
        }
        return _onClauseInline ? getRealAliasName() + "." + columnName
                : columnName;
    }

    @Override
    protected void registerExistsSubQuery(ConditionQuery subQuery,
            String columnName, String relatedColumnName, String propertyName) {
        throw new UnsupportedOperationException(
                "Sorry! ExistsSubQuery at inline view is unsupported. So please use InScopeSubQyery.");
    }

    // ===================================================================================
    //                                                                Override about Query
    //                                                                ====================
    protected ConditionValue getCValueId() {
        return _myCQ.getId();
    }

    public String keepId_InScopeSubQuery_RequestHeaderList(
            RequestHeaderCQ subQuery) {
        return _myCQ.keepId_InScopeSubQuery_RequestHeaderList(subQuery);
    }

    public String keepId_InScopeSubQuery_WebAuthenticationList(
            WebAuthenticationCQ subQuery) {
        return _myCQ.keepId_InScopeSubQuery_WebAuthenticationList(subQuery);
    }

    public String keepId_InScopeSubQuery_WebConfigToBrowserTypeMappingList(
            WebConfigToBrowserTypeMappingCQ subQuery) {
        return _myCQ
                .keepId_InScopeSubQuery_WebConfigToBrowserTypeMappingList(subQuery);
    }

    public String keepId_InScopeSubQuery_WebConfigToLabelTypeMappingList(
            WebConfigToLabelTypeMappingCQ subQuery) {
        return _myCQ
                .keepId_InScopeSubQuery_WebConfigToLabelTypeMappingList(subQuery);
    }

    public String keepId_InScopeSubQuery_WebConfigToRoleTypeMappingList(
            WebConfigToRoleTypeMappingCQ subQuery) {
        return _myCQ
                .keepId_InScopeSubQuery_WebConfigToRoleTypeMappingList(subQuery);
    }

    public String keepId_NotInScopeSubQuery_RequestHeaderList(
            RequestHeaderCQ subQuery) {
        return _myCQ.keepId_NotInScopeSubQuery_RequestHeaderList(subQuery);
    }

    public String keepId_NotInScopeSubQuery_WebAuthenticationList(
            WebAuthenticationCQ subQuery) {
        return _myCQ.keepId_NotInScopeSubQuery_WebAuthenticationList(subQuery);
    }

    public String keepId_NotInScopeSubQuery_WebConfigToBrowserTypeMappingList(
            WebConfigToBrowserTypeMappingCQ subQuery) {
        return _myCQ
                .keepId_NotInScopeSubQuery_WebConfigToBrowserTypeMappingList(subQuery);
    }

    public String keepId_NotInScopeSubQuery_WebConfigToLabelTypeMappingList(
            WebConfigToLabelTypeMappingCQ subQuery) {
        return _myCQ
                .keepId_NotInScopeSubQuery_WebConfigToLabelTypeMappingList(subQuery);
    }

    public String keepId_NotInScopeSubQuery_WebConfigToRoleTypeMappingList(
            WebConfigToRoleTypeMappingCQ subQuery) {
        return _myCQ
                .keepId_NotInScopeSubQuery_WebConfigToRoleTypeMappingList(subQuery);
    }

    public String keepId_ExistsSubQuery_RequestHeaderList(
            RequestHeaderCQ subQuery) {
        throw new UnsupportedOperationException(
                "ExistsSubQuery at inline() is unsupported! Sorry!");
    }

    public String keepId_ExistsSubQuery_WebAuthenticationList(
            WebAuthenticationCQ subQuery) {
        throw new UnsupportedOperationException(
                "ExistsSubQuery at inline() is unsupported! Sorry!");
    }

    public String keepId_ExistsSubQuery_WebConfigToBrowserTypeMappingList(
            WebConfigToBrowserTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "ExistsSubQuery at inline() is unsupported! Sorry!");
    }

    public String keepId_ExistsSubQuery_WebConfigToLabelTypeMappingList(
            WebConfigToLabelTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "ExistsSubQuery at inline() is unsupported! Sorry!");
    }

    public String keepId_ExistsSubQuery_WebConfigToRoleTypeMappingList(
            WebConfigToRoleTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "ExistsSubQuery at inline() is unsupported! Sorry!");
    }

    public String keepId_NotExistsSubQuery_RequestHeaderList(
            RequestHeaderCQ subQuery) {
        throw new UnsupportedOperationException(
                "NotExistsSubQuery at inline() is unsupported! Sorry!");
    }

    public String keepId_NotExistsSubQuery_WebAuthenticationList(
            WebAuthenticationCQ subQuery) {
        throw new UnsupportedOperationException(
                "NotExistsSubQuery at inline() is unsupported! Sorry!");
    }

    public String keepId_NotExistsSubQuery_WebConfigToBrowserTypeMappingList(
            WebConfigToBrowserTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "NotExistsSubQuery at inline() is unsupported! Sorry!");
    }

    public String keepId_NotExistsSubQuery_WebConfigToLabelTypeMappingList(
            WebConfigToLabelTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "NotExistsSubQuery at inline() is unsupported! Sorry!");
    }

    public String keepId_NotExistsSubQuery_WebConfigToRoleTypeMappingList(
            WebConfigToRoleTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "NotExistsSubQuery at inline() is unsupported! Sorry!");
    }

    public String keepId_SpecifyDerivedReferrer_RequestHeaderList(
            RequestHeaderCQ subQuery) {
        throw new UnsupportedOperationException(
                "(Specify)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_SpecifyDerivedReferrer_WebAuthenticationList(
            WebAuthenticationCQ subQuery) {
        throw new UnsupportedOperationException(
                "(Specify)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_SpecifyDerivedReferrer_WebConfigToBrowserTypeMappingList(
            WebConfigToBrowserTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "(Specify)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_SpecifyDerivedReferrer_WebConfigToLabelTypeMappingList(
            WebConfigToLabelTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "(Specify)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_SpecifyDerivedReferrer_WebConfigToRoleTypeMappingList(
            WebConfigToRoleTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "(Specify)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_QueryDerivedReferrer_RequestHeaderList(
            RequestHeaderCQ subQuery) {
        throw new UnsupportedOperationException(
                "(Query)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_QueryDerivedReferrer_RequestHeaderListParameter(
            Object parameterValue) {
        throw new UnsupportedOperationException(
                "(Query)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_QueryDerivedReferrer_WebAuthenticationList(
            WebAuthenticationCQ subQuery) {
        throw new UnsupportedOperationException(
                "(Query)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_QueryDerivedReferrer_WebAuthenticationListParameter(
            Object parameterValue) {
        throw new UnsupportedOperationException(
                "(Query)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_QueryDerivedReferrer_WebConfigToBrowserTypeMappingList(
            WebConfigToBrowserTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "(Query)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_QueryDerivedReferrer_WebConfigToBrowserTypeMappingListParameter(
            Object parameterValue) {
        throw new UnsupportedOperationException(
                "(Query)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_QueryDerivedReferrer_WebConfigToLabelTypeMappingList(
            WebConfigToLabelTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "(Query)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_QueryDerivedReferrer_WebConfigToLabelTypeMappingListParameter(
            Object parameterValue) {
        throw new UnsupportedOperationException(
                "(Query)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_QueryDerivedReferrer_WebConfigToRoleTypeMappingList(
            WebConfigToRoleTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "(Query)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_QueryDerivedReferrer_WebConfigToRoleTypeMappingListParameter(
            Object parameterValue) {
        throw new UnsupportedOperationException(
                "(Query)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    protected ConditionValue getCValueName() {
        return _myCQ.getName();
    }

    protected ConditionValue getCValueUrls() {
        return _myCQ.getUrls();
    }

    protected ConditionValue getCValueIncludedUrls() {
        return _myCQ.getIncludedUrls();
    }

    protected ConditionValue getCValueExcludedUrls() {
        return _myCQ.getExcludedUrls();
    }

    protected ConditionValue getCValueDepth() {
        return _myCQ.getDepth();
    }

    protected ConditionValue getCValueMaxAccessCount() {
        return _myCQ.getMaxAccessCount();
    }

    protected ConditionValue getCValueUserAgent() {
        return _myCQ.getUserAgent();
    }

    protected ConditionValue getCValueNumOfThread() {
        return _myCQ.getNumOfThread();
    }

    protected ConditionValue getCValueIntervalTime() {
        return _myCQ.getIntervalTime();
    }

    protected ConditionValue getCValueAvailable() {
        return _myCQ.getAvailable();
    }

    protected ConditionValue getCValueSortOrder() {
        return _myCQ.getSortOrder();
    }

    protected ConditionValue getCValueCreatedBy() {
        return _myCQ.getCreatedBy();
    }

    protected ConditionValue getCValueCreatedTime() {
        return _myCQ.getCreatedTime();
    }

    protected ConditionValue getCValueUpdatedBy() {
        return _myCQ.getUpdatedBy();
    }

    protected ConditionValue getCValueUpdatedTime() {
        return _myCQ.getUpdatedTime();
    }

    protected ConditionValue getCValueDeletedBy() {
        return _myCQ.getDeletedBy();
    }

    protected ConditionValue getCValueDeletedTime() {
        return _myCQ.getDeletedTime();
    }

    protected ConditionValue getCValueVersionNo() {
        return _myCQ.getVersionNo();
    }

    // ===================================================================================
    //                                                                     Scalar SubQuery
    //                                                                     ===============
    public String keepScalarSubQuery(WebCrawlingConfigCQ subQuery) {
        throw new UnsupportedOperationException(
                "ScalarSubQuery at inline() is unsupported! Sorry!");
    }

    // ===================================================================================
    //                                                             MySelf InScope SubQuery
    //                                                             =======================
    public String keepMyselfInScopeSubQuery(WebCrawlingConfigCQ subQuery) {
        throw new UnsupportedOperationException(
                "MyselfInScopeSubQuery at inline() is unsupported! Sorry!");
    }

    // ===================================================================================
    //                                                                       Very Internal
    //                                                                       =============
    // Very Internal (for Suppressing Warn about 'Not Use Import')
    String xiCB() {
        return WebCrawlingConfigCB.class.getName();
    }

    String xiCQ() {
        return WebCrawlingConfigCQ.class.getName();
    }
}
